﻿//***************************************************************************
//
//    Copyright (c) Microsoft Corporation. All rights reserved.
//    This code is licensed under the Visual Studio SDK license terms.
//    THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
//    ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
//    IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
//    PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//***************************************************************************

using System;
using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Text;
using Microsoft.VisualStudio.Text.Tagging;
using Microsoft.VisualStudio.Utilities;
using Microsoft.VisualStudio.TeamArchitect.PowerTools;
using Microsoft.VisualStudio.TeamArchitect.PowerTools.Features;
using Microsoft.VisualStudio.ComponentModelHost;
using Microsoft.VisualStudio.Shell;
using Microsoft.VisualStudio.Shell.Interop;
using Microsoft.VisualStudio.ExtensibilityHosting;


namespace $safeprojectname$
{
    [Export(typeof(ITaggerProvider))]
    [ContentType("text")]
    [TagType(typeof(GuidanceTag))]
    internal sealed class GuidanceTaggerProvider : ITaggerProvider
    {
        [Import]
        public IFeatureManager theFeatureManager { get; set; }


        [Import]
        public SVsServiceProvider ServiceProvider { get; set; }

        public static IFeatureManager ourFM;

        public ITagger<T> CreateTagger<T>(ITextBuffer buffer) where T : ITag
        {

            ourFM = theFeatureManager;

            if (buffer == null)
                throw new ArgumentNullException("buffer");

            return buffer.Properties.GetOrCreateSingletonProperty<GuidanceTagger>(() => new GuidanceTagger(buffer)) as ITagger<T>;
        }
    }
}
