using Microsoft.VisualStudio.TeamArchitect.PowerTools.Features;

namespace InstantFeatureBuilder
{
    public partial class ProcessWorkflow
    {
        protected override void OnInitialize()
        {
            base.OnInitialize();
            this.Name = "GuidanceWorkflow";

            var initial = new Initial
            {
                Name = "Initial1",
            };
            var guidanceAction0 = new GuidanceAction
            {
                Name = "Overview",
                Link = "content://./Content/ProcessGuidance/Overview.mht",
            };
            guidanceAction0.Postconditions.Add(new UserAcceptanceBinding(guidanceAction0));
            var final0 = new Final
            {
                Name = "ActivityFinal1",
            };

            this.ConnectTo(initial);
            initial.ConnectTo(guidanceAction0);
            guidanceAction0.ConnectTo(final0);

            this.OnPostInitialize();
        }

        partial void OnPostInitialize();
    }
}