﻿using System;
using System.ComponentModel.Composition;
using System.Linq;

using Microsoft.VisualStudio.TeamArchitect.PowerTools.Features;
using Microsoft.VisualStudio.TeamArchitect.PowerTools.Features.Diagnostics;
using System.Windows.Forms;

namespace InstantFeatureBuilder
{
    [LaunchPoint(Id = "VsTemplateLaunchPoint1")]
    public partial class VsTemplateLaunchPoint1 : VsTemplateLaunchPoint
    {
        public const string TemplateName = "~~Change-to-match-your-template-name~~";
        public const string TemplateCategory = "CSharp";
        public const string TemplateId = "";

        [ImportingConstructor]
        public VsTemplateLaunchPoint1(IFeatureManager featureManager)
            : base(featureManager, TemplateId, TemplateName, TemplateCategory)
        {
        }

        public override FeatureInstantiation FeatureInstantiation
        {
            get { return FeatureInstantiation.MultipleInstance; }
        }

        public override bool IsDefaultTemplate
        {
            get { return false; }
        }

        public override void OnBeforeUnfoldTemplate()
        {
            MessageBox.Show("Before Template Unfold");
        }

        public override void OnAfterUnfoldTemplate()
        {
            MessageBox.Show("After Template Unfold");
        }
    }
}
